#define _WIN32_DCOM
#include <windows.h>
#import "C:/Mr_Roy/Code\Code C++ .NET/420KE6/CDieseListeurProfs/obj/Debug/CDieseListeurProfs.tlb" named_guids
#include <iostream>
#include <ChargeurCOM.h>

int main ()
{
   ChargeurCOM cc;
   IUnknown *pUnk = 0;
   HRESULT hr = ::CoCreateInstance
      (CDieseListeurProfs::CLSID_Listeur, 0, CLSCTX_INPROC_SERVER,
       IID_IUnknown, reinterpret_cast<void **>(&pUnk));

   if (FAILED (hr))
      return -1;
   CDieseListeurProfs::IListeurProfs *pListerProfs = 0;
   hr = pUnk->QueryInterface (CDieseListeurProfs::IID_IListeurProfs, reinterpret_cast<void **>(&pListerProfs));
   pUnk->Release ();
   if (SUCCEEDED (hr))
   {
      int Nb = pListerProfs->GetNbProfs ();
      std::cout << "Nb profs disponibles: " << Nb << std::endl;
      if (Nb > 0)
      {
         SAFEARRAYBOUND sab[1];
         sab[0].lLbound = 0;
         sab[0].cElements = Nb;
         SAFEARRAY *pNoms = ::SafeArrayCreate (VT_LPWSTR, 1, sab);
         long NbObtenus = 0;
         pListerProfs->GetProfs (Nb, &pNoms, &NbObtenus);
         for (long i = 0; i < NbObtenus; i++)
         {
            BSTR str;
            ::SafeArrayGetElement (pNoms, &i, &str);
            std::wcout << str;
         }
         hr = ::SafeArrayDestroy (pNoms);
      }
      pListerProfs->Release ();
   }
}